/* $Id: utils.js,v 1.4 2005/05/13 14:59:23 ebricca Exp $ */
/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 *
 * The Initial Developer of the Original Code is
 * Ernesto Bricca.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// dump service  ----

function dumpStatusBar(aString)
{
// !!! not usable .. the user wont notice that .. instead use browsermessage
// dumps the msg in the status bar and if the debug is set also dumps to the javascript console
	if (prefs.talktoPref(comVar.DEBUG_ID)){ dumpme('statusbar dump: ' + aString); }
	var statusTextFld = document.getElementById("statusbar-display");
	statusTextFld.label = aString;

}

function dumpBrowserMsg(aString, buttonTxt)
{
//  browsermessage -- bloob that shows up atop of the rendered page (like on non trusted extension inst)
//  http://lxr.mozilla.org/mozilla/source/browser/base/content/browser.js#478
//  http://lxr.mozilla.org/mozilla/source/toolkit/content/widgets/tabbrowser.xml#202
    
//  getBrowser(), gBrowser  --  only exists in the browser.xul scope like in refspoof_overlay
//  document.getElementById("content");  is same ..
//  gBrowser.showMessage(gBrowser.mCurrentBrowser, null/*img*/, "message", "button",
//  null, null , "toolbar-context-menu", "top", true/*close x*/); 
    
    if (buttonTxt == null) {
        buttonTxt = "clickOnMe/messageBar";
    }
    
    gBrowser.showMessage(gBrowser.mCurrentBrowser, null/*img*/, aString,
            buttonTxt, null, null , "helpPopup", "top", true/*close x*/);     
    
//  browser.showMessage(browser.selectedBrowser, "", aString, "", 
//  browser.docShell, 
    //	null, "helpPopup" , "top", true); //last entry true gives an x
}

function dumpBrowserMsgBlink(aString)
{
// not usable irritates too much
browser = getBrowser();

browser.showMessage(browser.selectedBrowser, "", aString, "", 
		browser.docShell, 
		null, null , "top", false); //last entry true gives an x

// flicker
// 6 s msg flicker .. function looses local vars
		setTimeout("getBrowser().hideMessage(getBrowser().selectedBrowser, 'top');",6000); 
}


function dumpAlert(aString)
{
// to refine could first getBrowser() via dom model
	alert(aString);

}

function dumpd(aString)
{
   if (prefs.talktoPref(comVar.DEBUG_ID)){ cdump('debug: ' + aString + '\n'); }
   //dump('debug: ' + aString + '\n');
};


function dumpme(aString)
{
//alert(aString);
	cdump(aString.toString() + '\n');

};

function cdump(s)
{
  var consoleService = getConsoleService();

  var excp;

  try
  {
    consoleService.logStringMessage(s);
  }
  catch(excp)
  {
  }

};


function getConsoleService()
{


  var excp;
  var gConsoleService;

  if (document.location.href.indexOf('chrome://') == -1)
  {
    try
    {
      netscape.security.PrivilegeManager.enablePrivilege(gConsoleSecurityPrivileges);
    }
    catch(excp)
    {
      alert(gConsoleSecurityMessage);
      return gConsoleService;
    }
  }

  try
  {
    gConsoleService = 
        Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService);
  }
  catch(excp)
  {
  }

  return gConsoleService;

}

// handle vars and defaults  (interfaces with prefs) ----

// common variables
var comVar = {

	RS_VERSION_ID : {id: "refspoof.version", def: "0.7.0"},
	// checklist where to modify version tag ..
	// change install.rdf
	// change update.rdf
	// generate xpi
	// move to downloads folder
	// change installation webpage
	// change info index webpage
	// cvs update
	// upload to mozilla.update

	

	URLBAR_ID : {gui: "urlbar"}, //from navigator.xul
	BM_BUTTON_ID : {gui: "rstb_bm_button"},
	SPOOF_BUTTON_ID : {gui: "rstb_spoof"},
	
	REFBAR_ID : {id: "refspoof.tb_refbar", def : 5, gui: "rstb_refbar"},
	URLISREF_ID : {id : "refspoof.tb_urlisref", def : false, gui: "rstb_urlref"},
	OPENTAB_ID : {id : "refspoof.tb_opentab", def : false, gui: "rstb_openTab"}, 

	//in lack of a better names
	STORE_METHOD_ID : {id : "refspoof.bmStoreMethod", def : 0, gui : "bmStoreMethod"},
	STORE_LOCATION_ID : {id : "refspoof.bmStoreLocation", def : 0, gui : "bmStoreLocation"},
	
	SIDEBAR_CONTENT_ID : {id : "refspoof.sidebarContent", def : 0, gui : "sidebarContent"}, 
	SIDEBAR_URI_ID : {id : "refspoof.sidebarURI", def : "http://google.com", gui: "sidebarURI"},
	
	DEBUG_ID : {id : "refspoof.debug", def : false, gui: "showLocalDebug"},
	URLREFNAG_ID : {id : "refspoof.urlrefnag", def : true, gui: "showUrlRefNag"},
	
	SPOOFMARK_FOLDER_ID : {id : "refspoof.folder_id", def : "NC:BookmarksRoot"},
	ALT_PRESSED_ID : {id : "refspoof.altPressed", def : 0},
	SHIFT_PRESSED_ID : {id : "refspoof.shiftPressed", def : 0},
	
	BROWSER_LOAD_TABS_IN_BG_ID : {id : "browser.tabs.loadInBackground", def : true},
 
}

// handle prefs----

var prefs = {

	// talktoPref needs to be able to handle passed objects *and* string values (prefsystem/self)
	// !no branch .. just clutters logic

	talktoPref : function (myId, myVal, myDefault) {
		if (myId == null) {
			dumpme("specify a store id");
			return null;
		} else {

			if (typeof(myId)=="object"){
				try {
				myIdString = myId.id;
				myDefault = myId.def;
	
				// on items not in list mostly not need as "specify a store id" normally comes first
				} catch (e) {dumpme("spat error:" + myId); return null;} 
				if (myId.id == "undefined"){dumpme(".id gave undefined:" + myId); return null;}
				if (myId.def == "undefined"){dumpme(".def gave undefined:" + myId); return null;}
			} 

			if (typeof(myId)=="string"){

				myIdString = myId;

				// myDefault should been given -- test

				if ((myVal == null) && (myDefault == null)){
					dumpme("no default was given .. bad!!");
					return null;
				}
			}

		}


		if (myVal == null) {
			try {
				return this.getPref(myIdString);
			} catch(ex) {
				return this.talktoPref(myIdString, myDefault); // set default
			}
		} else {
			try {
				this.setPref(myIdString, myVal);
				return this.getPref(myIdString);
			} catch(ex) {
				dumpme("bad as - " + ex + " - should have been catched earlier -- happens on wrong format")
			}
		}


		return null;
	},


	getPref : function (myId, myBranch) {
		var myPrefS = this.grabPrefS(myBranch);
         var type=myPrefS.getPrefType(myId); //bool==128, string==32, int==64
		//dumpd( myId + "on branch" + myBranch +" = " + type + " -- bool==128, string==32, int==64");
		switch (type){
			case 32:
				return myPrefS.getCharPref(myId);
			case 64:
				return myPrefS.getIntPref(myId);
			case 128:
				return myPrefS.getBoolPref(myId);
			case 0:
				throw "pref not defined";
		}
 		 dumpme("no get matchtype");
 		 return null;
	},

	setPref : function (myId, myVal, myBranch) {
		myPrefS = this.grabPrefS(myBranch);
		type = typeof(myVal);
		//dumpd(myId + " = " + type);
		switch (type){
			case "string":
				return myPrefS.setCharPref(myId, myVal);
			case "number":
				return myPrefS.setIntPref(myId, myVal);
			case "boolean":
				return myPrefS.setBoolPref(myId, myVal);
		}
  		dumpme("no set matchtype");
  		return null;
	},

	grabPrefS : function (myBranch) {
		if (!this.myPrefS){
			this.myPrefS = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		}
		if (myBranch == null) {
		myBranch = "";
		}
		return this.myPrefS.getBranch(myBranch);
	},
	
	
	// remove all preferences can be invoced via js shell (use convert.xul scope)
	removePrefs: function() {
		var prefBranch = this.grabPrefS("refspoof.");

		try {
			prefBranch.deleteBranch("");
			return true;
		} catch(e) {
			return false;
		}
	}
	
}


function detectKbSwitch(event, myId, myKey) {
	var pressed=false;
	if (myKey=="alt") {
		if (event.altKey){
			pressed=true;
		}
	} else if (myKey=="shift"){
		if (event.shiftKey){
			pressed=true;
		}
	}

	if (pressed) {
		// testline of the using script
		//Boolean(Number(prefs.talktoPref(myId, null, 0)));
		// note to be resetted !!before usage in the xul .. call resetKbSwitch(myId)
		prefs.talktoPref(myId, 1);
	}

};

function resetKbSwitch(myId) {

// needs to be called at the end of the instruction that uses detectKbSwitch 

	prefs.talktoPref(myId, 0);

};

function openMyHelp() {

	var helpUri = "chrome://refspoof/locale/help.html"
	
	if (typeof(getBrowser)=='function'){
		getBrowser().loadURI(helpUri);
	} else {
		window.open(helpUri);
	} 
};

function versionTag() {

	prefs.talktoPref(comVar.RS_VERSION_ID, comVar.RS_VERSION_ID.def);

};
